SerializationConfig
Date: 2016-12-04

com.fasterxml.jackson.databind

## Class SerializationConfig

- java.lang.Object
- - com.fasterxml.jackson.databind.cfg.MapperConfig<T>
  - - com.fasterxml.jackson.databind.cfg.MapperConfigBase<SerializationFeature,SerializationConfig>
    - - com.fasterxml.jackson.databind.SerializationConfig

- All Implemented Interfaces:
    ClassIntrospector.MixInResolver, java.io.Serializable

      public final class SerializationConfig
      extends MapperConfigBase<SerializationFeature,SerializationConfig>
      implements java.io.Serializable

  Object that contains baseline configuration for serialization process. An instance is owned by `ObjectMapper`, which passes an immutable instance for serialization process to `SerializerProvider` and `SerializerFactory` (either directly, or through `ObjectWriter`.

  Note that instances are considered immutable and as such no copies should need to be created for sharing; all copying is done with "fluent factory" methods.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected com.fasterxml.jackson.core.PrettyPrinter` | `_defaultPrettyPrinter` If "default pretty-printing" is enabled, it will create the instance from this blueprint object.
    `protected FilterProvider` | `_filterProvider` Object used for resolving filter ids to filter instances.
    `protected int` | `_formatWriteFeatures` States of `FormatFeature`s to enable/disable.
    `protected int` | `_formatWriteFeaturesToChange` Bitflag of `FormatFeature`s to enable/disable
    `protected int` | `_generatorFeatures` States of `JsonGenerator.Feature`s to enable/disable.
    `protected int` | `_generatorFeaturesToChange` Bitflag of `JsonGenerator.Feature`s to enable/disable
    `protected int` | `_serFeatures` Set of `SerializationFeature`s enabled.
    `protected com.fasterxml.jackson.annotation.JsonInclude.Value` | `_serializationInclusion` Which Bean/Map properties are to be included in serialization? Default settings is to include all regardless of value; can be changed to only include non-null properties, or properties with non-default values.
    `protected static com.fasterxml.jackson.annotation.JsonInclude.Value` | `DEFAULT_INCLUSION`
    `protected static com.fasterxml.jackson.core.PrettyPrinter` | `DEFAULT_PRETTY_PRINTER`

    - ### Fields inherited from class com.fasterxml.jackson.databind.cfg.MapperConfigBase

      `_attributes, _configOverrides, _mixIns, _rootName, _rootNames, _subtypeResolver, _view`

    - ### Fields inherited from class com.fasterxml.jackson.databind.cfg.MapperConfig

      `_base, _mapperFeatures, EMPTY_FORMAT, EMPTY_INCLUDE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `SerializationConfig(BaseSettings base, SubtypeResolver str, SimpleMixInResolver mixins, RootNameLookup rootNames)` Deprecated. Since 2.8, remove from 2.9 or later
    `` | `SerializationConfig(BaseSettings base, SubtypeResolver str, SimpleMixInResolver mixins, RootNameLookup rootNames, ConfigOverrides configOverrides)` Constructor used by ObjectMapper to create default configuration object instance.
    `protected` | `SerializationConfig(SerializationConfig src, ContextAttributes attrs)`
    `protected` | `SerializationConfig(SerializationConfig src, com.fasterxml.jackson.core.PrettyPrinter defaultPP)`
    `protected` | `SerializationConfig(SerializationConfig src, SimpleMixInResolver mixins)`
    `protected` | `SerializationConfig(SerializationConfig src, SimpleMixInResolver mixins, RootNameLookup rootNames, ConfigOverrides configOverrides)` Copy-constructor used for making a copy to be used by new `ObjectMapper`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.fasterxml.jackson.core.PrettyPrinter` | `constructDefaultPrettyPrinter()`
    `AnnotationIntrospector` | `getAnnotationIntrospector()` Method for getting `AnnotationIntrospector` configured to introspect annotation values used for configuration.
    `com.fasterxml.jackson.core.PrettyPrinter` | `getDefaultPrettyPrinter()` Accessor for configured blueprint "default" `PrettyPrinter` to use, if default pretty-printing is enabled.
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion()` Accessor for default property inclusion to use for serialization, used unless overridden by per-type or per-property overrides.
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion(java.lang.Class<?> baseType)` Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type. NOTE: if no override found, defaults to value returned by `MapperConfig.getDefaultPropertyInclusion()`.
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion(java.lang.Class<?> baseType, com.fasterxml.jackson.annotation.JsonInclude.Value defaultIncl)` Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type; but if none found, returning given `defaultIncl`
    `FilterProvider` | `getFilterProvider()` Method for getting provider used for locating filters given id (which is usually provided with filter annotations).
    `int` | `getSerializationFeatures()`
    `com.fasterxml.jackson.annotation.JsonInclude.Include` | `getSerializationInclusion()` Deprecated. Since 2.7 use `getDefaultPropertyInclusion()` instead
    `boolean` | `hasSerializationFeatures(int featureMask)` "Bulk" access method for checking that all features specified by mask are enabled.
    `void` | `initialize(com.fasterxml.jackson.core.JsonGenerator g)` Method called by `ObjectMapper` and `ObjectWriter` to modify those `JsonGenerator.Feature` settings that have been configured via this config instance.
    `<T extends BeanDescription> T` | `introspect(JavaType type)` Method that will introspect full bean properties for the purpose of building a bean serializer
    `BeanDescription` | `introspectClassAnnotations(JavaType type)` Accessor for getting bean description that only contains class annotations: useful if no getter/setter/creator information is needed.
    `BeanDescription` | `introspectDirectClassAnnotations(JavaType type)` Accessor for getting bean description that only contains immediate class annotations: ones from the class, and its direct mix-in, if any, but not from super types.
    `boolean` | `isEnabled(com.fasterxml.jackson.core.JsonGenerator.Feature f, com.fasterxml.jackson.core.JsonFactory factory)` Accessor method that first checks if we have any overrides for feature, and only if not, checks state of passed-in factory.
    `boolean` | `isEnabled(SerializationFeature f)`
    `java.lang.String` | `toString()`
    `boolean` | `useRootWrapping()` Accessor for checking whether configuration indicates that "root wrapping" (use of an extra property/name pair at root level) is expected or not.
    `SerializationConfig` | `with(AnnotationIntrospector ai)` Method for constructing and returning a new instance with different `AnnotationIntrospector` to use (replacing old one).
    `SerializationConfig` | `with(com.fasterxml.jackson.core.Base64Variant base64)` Method for constructing and returning a new instance with different default `Base64Variant` to use with base64-encoded binary values.
    `SerializationConfig` | `with(ClassIntrospector ci)` Method for constructing and returning a new instance with different `ClassIntrospector` to use.
    `SerializationConfig` | `with(ContextAttributes attrs)` Method for constructing an instance that has specified contextual attributes.
    `SerializationConfig` | `with(java.text.DateFormat df)` In addition to constructing instance with specified date format, will enable or disable `SerializationFeature.WRITE_DATES_AS_TIMESTAMPS` (enable if format set as null; disable if non-null)
    `SerializationConfig` | `with(com.fasterxml.jackson.core.FormatFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.
    `SerializationConfig` | `with(HandlerInstantiator hi)` Method for constructing and returning a new instance with different `HandlerInstantiator` to use.
    `SerializationConfig` | `with(com.fasterxml.jackson.core.JsonGenerator.Feature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.
    `SerializationConfig` | `with(java.util.Locale l)` Method for constructing and returning a new instance with different default `Locale` to use for formatting.
    `SerializationConfig` | `with(MapperFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `SerializationConfig` | `with(MapperFeature feature, boolean state)`
    `SerializationConfig` | `with(PropertyNamingStrategy pns)` Method for constructing and returning a new instance with different `PropertyNamingStrategy` to use.
    `SerializationConfig` | `with(SerializationFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.
    `SerializationConfig` | `with(SerializationFeature first, SerializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `SerializationConfig` | `with(SubtypeResolver str)` Method for constructing and returning a new instance with different `SubtypeResolver` to use.
    `SerializationConfig` | `with(java.util.TimeZone tz)` Method for constructing and returning a new instance with different default `TimeZone` to use for formatting of date values.
    `SerializationConfig` | `with(TypeFactory tf)` Method for constructing and returning a new instance with different `TypeFactory` to use.
    `SerializationConfig` | `with(TypeResolverBuilder<?> trb)` Method for constructing and returning a new instance with different `TypeResolverBuilder` to use.
    `SerializationConfig` | `with(VisibilityChecker<?> vc)` Method for constructing and returning a new instance with different `VisibilityChecker` to use.
    `SerializationConfig` | `withAppendedAnnotationIntrospector(AnnotationIntrospector ai)` Method for constructing and returning a new instance with additional `AnnotationIntrospector` appended (as the lowest priority one)
    `SerializationConfig` | `withDefaultPrettyPrinter(com.fasterxml.jackson.core.PrettyPrinter pp)`
    `SerializationConfig` | `withFeatures(com.fasterxml.jackson.core.FormatFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `SerializationConfig` | `withFeatures(com.fasterxml.jackson.core.JsonGenerator.Feature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `SerializationConfig` | `withFeatures(SerializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `SerializationConfig` | `withFilters(FilterProvider filterProvider)`
    `SerializationConfig` | `withInsertedAnnotationIntrospector(AnnotationIntrospector ai)` Method for constructing and returning a new instance with additional `AnnotationIntrospector` inserted (as the highest priority one)
    `SerializationConfig` | `without(com.fasterxml.jackson.core.FormatFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `SerializationConfig` | `without(com.fasterxml.jackson.core.JsonGenerator.Feature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `SerializationConfig` | `without(MapperFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `SerializationConfig` | `without(SerializationFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `SerializationConfig` | `without(SerializationFeature first, SerializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `SerializationConfig` | `withoutFeatures(com.fasterxml.jackson.core.FormatFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `SerializationConfig` | `withoutFeatures(com.fasterxml.jackson.core.JsonGenerator.Feature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `SerializationConfig` | `withoutFeatures(SerializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `SerializationConfig` | `withPropertyInclusion(com.fasterxml.jackson.annotation.JsonInclude.Value incl)`
    `SerializationConfig` | `withRootName(PropertyName rootName)` Method for constructing and returning a new instance with different root name to use (none, if null).
    `SerializationConfig` | `withSerializationInclusion(com.fasterxml.jackson.annotation.JsonInclude.Include incl)` Deprecated. Since 2.7 use `withPropertyInclusion(com.fasterxml.jackson.annotation.JsonInclude.Value)` instead
    `SerializationConfig` | `withView(java.lang.Class<?> view)` Method for constructing and returning a new instance with different view to use.
    `SerializationConfig` | `withVisibility(com.fasterxml.jackson.annotation.PropertyAccessor forMethod, com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility visibility)` Method for constructing and returning a new instance with different minimal visibility level for specified property type

    - ### Methods inherited from class com.fasterxml.jackson.databind.cfg.MapperConfigBase

      `copy, findConfigOverride, findMixInClassFor, findRootName, findRootName, getActiveView, getAttributes, getDefaultPropertyFormat, getDefaultPropertyIgnorals, getDefaultPropertyIgnorals, getDefaultVisibilityChecker, getFullRootName, getRootName, getSubtypeResolver, mixInCount, withAttribute, withAttributes, withoutAttribute, withRootName`

    - ### Methods inherited from class com.fasterxml.jackson.databind.cfg.MapperConfig

      `canOverrideAccessModifiers, collectFeatureDefaults, compileString, constructSpecializedType, constructType, constructType, getBase64Variant, getClassIntrospector, getDateFormat, getDefaultTyper, getHandlerInstantiator, getLocale, getPropertyNamingStrategy, getTimeZone, getTypeFactory, hasMapperFeatures, introspectClassAnnotations, introspectDirectClassAnnotations, isAnnotationProcessingEnabled, isEnabled, shouldSortPropertiesAlphabetically, typeIdResolverInstance, typeResolverBuilderInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PRETTY_PRINTER

          protected static final com.fasterxml.jackson.core.PrettyPrinter DEFAULT_PRETTY_PRINTER

    - #### DEFAULT_INCLUSION

          protected static final com.fasterxml.jackson.annotation.JsonInclude.Value DEFAULT_INCLUSION

    - #### _filterProvider

          protected final FilterProvider _filterProvider

      Object used for resolving filter ids to filter instances. Non-null if explicitly defined; null by default.

    - #### _defaultPrettyPrinter

          protected final com.fasterxml.jackson.core.PrettyPrinter _defaultPrettyPrinter

      If "default pretty-printing" is enabled, it will create the instance from this blueprint object.
      Since:
        2.6

    - #### _serFeatures

          protected final int _serFeatures

      Set of `SerializationFeature`s enabled.

    - #### _generatorFeatures

          protected final int _generatorFeatures

      States of `JsonGenerator.Feature`s to enable/disable.

    - #### _generatorFeaturesToChange

          protected final int _generatorFeaturesToChange

      Bitflag of `JsonGenerator.Feature`s to enable/disable

    - #### _formatWriteFeatures

          protected final int _formatWriteFeatures

      States of `FormatFeature`s to enable/disable.
      Since:
        2.7

    - #### _formatWriteFeaturesToChange

          protected final int _formatWriteFeaturesToChange

      Bitflag of `FormatFeature`s to enable/disable
      Since:
        2.7

    - #### _serializationInclusion

          protected final com.fasterxml.jackson.annotation.JsonInclude.Value _serializationInclusion

      Which Bean/Map properties are to be included in serialization? Default settings is to include all regardless of value; can be changed to only include non-null properties, or properties with non-default values.

      NOTE: type changed in 2.7, to include both value and content inclusion options./

  - ### Constructor Detail

    - #### SerializationConfig

          public SerializationConfig(BaseSettings base,
                             SubtypeResolver str,
                             SimpleMixInResolver mixins,
                             RootNameLookup rootNames,
                             ConfigOverrides configOverrides)

      Constructor used by ObjectMapper to create default configuration object instance.

    - #### SerializationConfig

          @Deprecated
          public SerializationConfig(BaseSettings base,
                                        SubtypeResolver str,
                                        SimpleMixInResolver mixins,
                                        RootNameLookup rootNames)

      Deprecated. Since 2.8, remove from 2.9 or later

    - #### SerializationConfig

          protected SerializationConfig(SerializationConfig src,
                             ContextAttributes attrs)

      Since:
        2.1

    - #### SerializationConfig

          protected SerializationConfig(SerializationConfig src,
                             SimpleMixInResolver mixins)

      Since:
        2.1

    - #### SerializationConfig

          protected SerializationConfig(SerializationConfig src,
                             com.fasterxml.jackson.core.PrettyPrinter defaultPP)

      Since:
        2.6

    - #### SerializationConfig

          protected SerializationConfig(SerializationConfig src,
                             SimpleMixInResolver mixins,
                             RootNameLookup rootNames,
                             ConfigOverrides configOverrides)

      Copy-constructor used for making a copy to be used by new `ObjectMapper`.
      Since:
        2.8

  - ### Method Detail

    - #### with

          public SerializationConfig with(MapperFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Specified by:
        `with` in class `MapperConfig<SerializationConfig>`

    - #### without

          public SerializationConfig without(MapperFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
      Specified by:
        `without` in class `MapperConfig<SerializationConfig>`

    - #### with

          public SerializationConfig with(MapperFeature feature,
                                 boolean state)

      Specified by:
        `with` in class `MapperConfig<SerializationConfig>`

    - #### with

          public SerializationConfig with(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `AnnotationIntrospector` to use (replacing old one).

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### withAppendedAnnotationIntrospector

          public SerializationConfig withAppendedAnnotationIntrospector(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with additional `AnnotationIntrospector` appended (as the lowest priority one)
      Specified by:
        `withAppendedAnnotationIntrospector` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### withInsertedAnnotationIntrospector

          public SerializationConfig withInsertedAnnotationIntrospector(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with additional `AnnotationIntrospector` inserted (as the highest priority one)
      Specified by:
        `withInsertedAnnotationIntrospector` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(ClassIntrospector ci)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `ClassIntrospector` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(java.text.DateFormat df)

      In addition to constructing instance with specified date format, will enable or disable `SerializationFeature.WRITE_DATES_AS_TIMESTAMPS` (enable if format set as null; disable if non-null)
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(HandlerInstantiator hi)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `HandlerInstantiator` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(PropertyNamingStrategy pns)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `PropertyNamingStrategy` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### withRootName

          public SerializationConfig withRootName(PropertyName rootName)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different root name to use (none, if null).

      Note that when a root name is set to a non-Empty String, this will automatically force use of root element wrapping with given name. If empty String passed, will disable root name wrapping; and if null used, will instead use `SerializationFeature` to determine if to use wrapping, and annotation (or default name) for actual root name to use.

      Specified by:
        `withRootName` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`
      Parameters:
        `rootName` - to use: if null, means "use default" (clear setting); if empty String ("") means that no root name wrapping is used; otherwise defines root name to use.

    - #### with

          public SerializationConfig with(SubtypeResolver str)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `SubtypeResolver` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(TypeFactory tf)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `TypeFactory` to use.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(TypeResolverBuilder<?> trb)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `TypeResolverBuilder` to use.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### withView

          public SerializationConfig withView(java.lang.Class<?> view)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different view to use.
      Specified by:
        `withView` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(VisibilityChecker<?> vc)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `VisibilityChecker` to use.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### withVisibility

          public SerializationConfig withVisibility(com.fasterxml.jackson.annotation.PropertyAccessor forMethod,
                                           com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility visibility)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different minimal visibility level for specified property type
      Specified by:
        `withVisibility` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(java.util.Locale l)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `Locale` to use for formatting.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(java.util.TimeZone tz)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `TimeZone` to use for formatting of date values.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(com.fasterxml.jackson.core.Base64Variant base64)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `Base64Variant` to use with base64-encoded binary values.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(ContextAttributes attrs)

      Description copied from class: `MapperConfigBase`
      Method for constructing an instance that has specified contextual attributes.
      Specified by:
        `with` in class `MapperConfigBase<SerializationFeature,SerializationConfig>`

    - #### with

          public SerializationConfig with(SerializationFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.

    - #### with

          public SerializationConfig with(SerializationFeature first,
                                 SerializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.

    - #### withFeatures

          public SerializationConfig withFeatures(SerializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.

    - #### without

          public SerializationConfig without(SerializationFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.

    - #### without

          public SerializationConfig without(SerializationFeature first,
                                    SerializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.

    - #### withoutFeatures

          public SerializationConfig withoutFeatures(SerializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.

    - #### with

          public SerializationConfig with(com.fasterxml.jackson.core.JsonGenerator.Feature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.
      Since:
        2.5

    - #### withFeatures

          public SerializationConfig withFeatures(com.fasterxml.jackson.core.JsonGenerator.Feature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.5

    - #### without

          public SerializationConfig without(com.fasterxml.jackson.core.JsonGenerator.Feature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
      Since:
        2.5

    - #### withoutFeatures

          public SerializationConfig withoutFeatures(com.fasterxml.jackson.core.JsonGenerator.Feature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
      Since:
        2.5

    - #### with

          public SerializationConfig with(com.fasterxml.jackson.core.FormatFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature enabled.
      Since:
        2.7

    - #### withFeatures

          public SerializationConfig withFeatures(com.fasterxml.jackson.core.FormatFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.7

    - #### without

          public SerializationConfig without(com.fasterxml.jackson.core.FormatFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
      Since:
        2.7

    - #### withoutFeatures

          public SerializationConfig withoutFeatures(com.fasterxml.jackson.core.FormatFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
      Since:
        2.7

    - #### withFilters

          public SerializationConfig withFilters(FilterProvider filterProvider)

    - #### withSerializationInclusion

          @Deprecated
          public SerializationConfig withSerializationInclusion(com.fasterxml.jackson.annotation.JsonInclude.Include incl)

      Deprecated. Since 2.7 use `withPropertyInclusion(com.fasterxml.jackson.annotation.JsonInclude.Value)` instead

    - #### withPropertyInclusion

          public SerializationConfig withPropertyInclusion(com.fasterxml.jackson.annotation.JsonInclude.Value incl)

      Since:
        2.7

    - #### withDefaultPrettyPrinter

          public SerializationConfig withDefaultPrettyPrinter(com.fasterxml.jackson.core.PrettyPrinter pp)

      Since:
        2.6

    - #### constructDefaultPrettyPrinter

          public com.fasterxml.jackson.core.PrettyPrinter constructDefaultPrettyPrinter()

    - #### initialize

          public void initialize(com.fasterxml.jackson.core.JsonGenerator g)

      Method called by `ObjectMapper` and `ObjectWriter` to modify those `JsonGenerator.Feature` settings that have been configured via this config instance.
      Since:
        2.5

    - #### getAnnotationIntrospector

          public AnnotationIntrospector getAnnotationIntrospector()

      Description copied from class: `MapperConfig`
      Method for getting `AnnotationIntrospector` configured to introspect annotation values used for configuration.

      Non-final since it is actually overridden by sub-classes (for now?)

      Overrides:
        `getAnnotationIntrospector` in class `MapperConfig<SerializationConfig>`

    - #### introspectClassAnnotations

          public BeanDescription introspectClassAnnotations(JavaType type)

      Accessor for getting bean description that only contains class annotations: useful if no getter/setter/creator information is needed.
      Specified by:
        `introspectClassAnnotations` in class `MapperConfig<SerializationConfig>`

    - #### introspectDirectClassAnnotations

          public BeanDescription introspectDirectClassAnnotations(JavaType type)

      Accessor for getting bean description that only contains immediate class annotations: ones from the class, and its direct mix-in, if any, but not from super types.
      Specified by:
        `introspectDirectClassAnnotations` in class `MapperConfig<SerializationConfig>`

    - #### getSerializationInclusion

          @Deprecated
          public com.fasterxml.jackson.annotation.JsonInclude.Include getSerializationInclusion()

      Deprecated. Since 2.7 use `getDefaultPropertyInclusion()` instead

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion()

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, used unless overridden by per-type or per-property overrides.
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<SerializationConfig>`

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion(java.lang.Class<?> baseType)

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type.
      NOTE: if no override found, defaults to value returned by `MapperConfig.getDefaultPropertyInclusion()`.
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<SerializationConfig>`

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion(java.lang.Class<?> baseType,
                                                                                       com.fasterxml.jackson.annotation.JsonInclude.Value defaultIncl)

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type; but if none found, returning given `defaultIncl`
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<SerializationConfig>`
        `defaultIncl` - Inclusion setting to return if no overrides found.

    - #### useRootWrapping

          public boolean useRootWrapping()

      Description copied from class: `MapperConfig`
      Accessor for checking whether configuration indicates that "root wrapping" (use of an extra property/name pair at root level) is expected or not.
      Specified by:
        `useRootWrapping` in class `MapperConfig<SerializationConfig>`

    - #### isEnabled

          public final boolean isEnabled(SerializationFeature f)

    - #### isEnabled

          public final boolean isEnabled(com.fasterxml.jackson.core.JsonGenerator.Feature f,
                          com.fasterxml.jackson.core.JsonFactory factory)

      Accessor method that first checks if we have any overrides for feature, and only if not, checks state of passed-in factory.
      Since:
        2.5

    - #### hasSerializationFeatures

          public final boolean hasSerializationFeatures(int featureMask)

      "Bulk" access method for checking that all features specified by mask are enabled.
      Since:
        2.3

    - #### getSerializationFeatures

          public final int getSerializationFeatures()

    - #### getFilterProvider

          public FilterProvider getFilterProvider()

      Method for getting provider used for locating filters given id (which is usually provided with filter annotations). Will be null if no provided was set for `ObjectWriter` (or if serialization directly called from `ObjectMapper`)

    - #### getDefaultPrettyPrinter

          public com.fasterxml.jackson.core.PrettyPrinter getDefaultPrettyPrinter()

      Accessor for configured blueprint "default" `PrettyPrinter` to use, if default pretty-printing is enabled.

      NOTE: returns the "blueprint" instance, and does NOT construct an instance ready to use; call `constructDefaultPrettyPrinter()` if actually usable instance is desired.

      Since:
        2.6

    - #### introspect

          public <T extends BeanDescription> T introspect(JavaType type)

      Method that will introspect full bean properties for the purpose of building a bean serializer

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`